# Basic installation

This page explains how to install SonarQube Server Developer or Enterprise edition from the Docker image and perform the basic setup.

## Prerequisites <a href="#prerequisites" id="prerequisites"></a>

You have:

* Performed the pre-installation checks:
  * [On Linux systems](/sonarqube-server/2025.3/server-installation/pre-installation/linux.md)
  * [On Unix-based systems](/sonarqube-server/2025.3/server-installation/pre-installation/unix.md)
  * [On macOS systems](/sonarqube-server/2025.3/server-installation/pre-installation/macos.md)
* Installed your database (except if you want to install SonarQube for test purposes and want to use the embedded database H2). See [Installing database](/sonarqube-server/2025.3/server-installation/installing-the-database.md).

## Create volumes to persist data <a href="#create-volumes" id="create-volumes"></a>

Creating the following volumes helps prevent the loss of information when updating to a new version or upgrading to a higher edition:

* * `sonarqube_data`: contains data files, such as Elasticsearch indexes
  * `sonarqube_logs`: contains SonarQube Server logs about access, web process, CE process, and Elasticsearch
  * `sonarqube_extensions`: will contain any plugins you install and the Oracle JDBC driver if necessary.

Create the volumes with the following commands:

```bash
docker volume create --name sonarqube_data
docker volume create --name sonarqube_logs
docker volume create --name sonarqube_extensions
```

{% hint style="warning" %}
Make sure you’re using [**volumes**](https://docs.docker.com/storage/volumes/) as shown with the above commands, and not [**bind mounts**](https://docs.docker.com/storage/bind-mounts/). Using bind mounts prevents plugins from populating correctly.
{% endhint %}

## Set access to the database <a href="#set-access-to-database" id="set-access-to-database"></a>

You must configure the access to your database (except if you want to use SonarQube for test purposes and want to use the embedded database H2):. To do so, set the system properties (environment variables) related to database access: see [List of properties common to all editions](/sonarqube-server/2025.3/server-installation/system-properties/common-properties.md#general).

## Oracle database: add the JDBC driver <a href="#add-jdbc-driver" id="add-jdbc-driver"></a>

Drivers for supported databases (except Oracle) are already provided. If you’re using an Oracle database, you need to add the JDBC driver to the `sonar_extensions` volume. To do this:

1\. Start the SonarQube Server container with the embedded H2 database:

```bash
docker run --rm \
    -p 9000:9000 \
    -v sonarqube_extensions:/opt/sonarqube/extensions \
    <image_name>
```

For `<image_name>`, check the tags currently available on the [DockerHub page](https://hub.docker.com/_/sonarqube).

2\. Exit once SonarQube Server has started properly.

3\. Copy the Oracle JDBC driver into `sonarqube_extensions/jdbc-driver/oracle`.

## Check the web server connection parameters <a href="#check-web-server-connection-parameters" id="check-web-server-connection-parameters"></a>

Check the default values in [List of properties common to all editions](/sonarqube-server/2025.3/server-installation/system-properties/common-properties.md#web-server-connection). Change the respective environment variables if necessary.

## Related pages <a href="#related-pages" id="related-pages"></a>

* [Installation overview](/sonarqube-server/2025.3/server-installation/from-docker-image/installation-overview.md)
* [Advanced setup](/sonarqube-server/2025.3/server-installation/from-docker-image/advanced-setup.md)
* **Configuring network security features:**
  * [Securing behind a proxy](/sonarqube-server/2025.3/server-installation/network-security/securing-behind-proxy.md)
  * [Network rules](/sonarqube-server/2025.3/server-installation/network-security/network-rules.md)
* [Starting SonarQube container](/sonarqube-server/2025.3/server-installation/from-docker-image/starting-sonarqube-container.md)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.sonarsource.com/sonarqube-server/2025.3/server-installation/from-docker-image/basic-installation.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
